var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { shouldSkip } from "feathers-utils";
import { makeOptions } from "./authorize.hook.utils";
import authorizeAfter from "./authorize.hook.after";
import authorizeBefore from "./authorize.hook.before";
const HOOKNAME = "authorize";
export default (options) => {
    return (context) => __awaiter(void 0, void 0, void 0, function* () {
        if (shouldSkip(HOOKNAME, context) ||
            !context.params ||
            context.type === "error") {
            return context;
        }
        const fullOptions = makeOptions(context.app, options);
        return (context.type === "before")
            ? yield authorizeBefore(fullOptions)(context)
            : yield authorizeAfter(fullOptions)(context);
    });
};
