import { makeDefaultOptions as makeDefaultAuthorizeHookOptions } from "./hooks/authorize/authorize.hook.utils";
import { makeDefaultOptions as makeDefaultChannelsOptions } from "./channels/channels.utils";
export default (options) => {
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    //@ts-ignore
    if (options === null || options === void 0 ? void 0 : options.version) {
        // asserts that you call app.configure(casl({})) instead of app.configure(casl)
        throw new Error("You passed 'feathers-casl' to app.configure() without a function. You probably wanted to call app.configure(casl({}))!");
    }
    options = {
        authorizeHook: makeDefaultAuthorizeHookOptions(options === null || options === void 0 ? void 0 : options.authorizeHook),
        channels: makeDefaultChannelsOptions(options === null || options === void 0 ? void 0 : options.channels)
    };
    return (app) => {
        if (app.get("casl")) {
            return;
        }
        app.set("casl", options);
    };
};
