import { mergeQuery } from "feathers-utils";
import getFieldsQueryFor from "./getFieldsQueryFor";
import getConditionalQueryFor from "./getConditionalQueryFor";
const getQueryFor = (ability, method, modelName, options) => {
    options = options || {
        availableFields: []
    };
    const { skipConditional, skipFields } = options;
    if (skipConditional && skipFields) {
        return {};
    }
    const conditionsQuery = (!skipConditional)
        ? getConditionalQueryFor(ability, method, modelName, { actionOnForbidden: options.actionOnForbidden })
        : {};
    const fieldsQuery = (!skipFields)
        ? getFieldsQueryFor(ability, method, modelName, { availableFields: options.availableFields })
        : {};
    const query = mergeQuery(conditionsQuery, fieldsQuery, { defaultHandle: "combine" });
    return query;
};
export default getQueryFor;
